﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace _24AlgONP
{
    public partial class Form1 : Form
    {
        Stack stos = new Stack();

        bool cyfra(char z)
        {
            //funkcja sprawdza czy znak jest cyfrą
            //zwróc wynik testu złożonego warunku logicznego
            //jak jest spełniony to PRAWDA, jak nie to FAŁSZ
            return z >= '0' && z <= '9';
        }
        bool dzialanie(char z)
        {
            //funkcja sprawdza czy znak jest operatorem
            //działania matematcznego
            return z == '+' ||//dodawanie
                   z == '-' ||//odejmowanie
                   z == '*' ||//mnozenie
                   z == '/';//dzielenie
        }
        float oblicz(float a,float b,char z)
        {
            switch (z)
            {
                case '+':return a + b;
                case '-': return a - b;
                case '*': return a * b;
                case '/': return a / b;
            }
            return 0;   
        }
        float dajLiczbe(string lancuch,int id)
        {
            //int j = id;
            //zamienia ciąg znaków na liczbę
            int liczba = 0;
            while(id<lancuch.Length && cyfra(lancuch[id]) && lancuch[id]!=' ')
            {
                //liczbe okresl na podstawie systemu pozycyjnego schematu Hornera
                //odczytaj cyfre z pozycji kodu ASCII
                liczba = liczba * 10 + lancuch[id] - '0';
                ++id;
            }
            return liczba;
        }
        
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string onp=textBox1.Text;
            //czysc poprzednią zawartośc stosu
            stos.Clear();
            for(int i = 0; i < onp.Length; i++)
            {
                if (cyfra(onp[i]))
                {
                    float liczba = dajLiczbe(onp, i);
                    //wrzuc odczytaną liczbę na stos danych
                    stos.Push(liczba);
                    //zwieksz krok o długośc znakow odczytanej liczby
                    i+=liczba.ToString().Length;    
                }
                else
                    if (dzialanie(onp[i]))
                    {
                        if (stos.Count < 2)
                        {
                            MessageBox.Show("To nie jest wyrażenie ONP",
                                            "Komunikat",
                                            MessageBoxButtons.OK,
                                            MessageBoxIcon.Error);
                            return;
                        }
                        float b = (float)stos.Peek();
                        stos.Pop();//usuń pobraną
                        float a = (float)stos.Peek();
                        stos.Pop();//usuń pobraną
                        //wrzuc biezacy wynik obliczeń
                        stos.Push(oblicz(a, b, onp[i]));
                    }//koniec if dzialanie
                
            }
            MessageBox.Show(((float)stos.Peek()).ToString(),
                            "Wynik",
                            MessageBoxButtons.OK,
                            MessageBoxIcon.Information);
        }
    }
}
